-- ESEGUITO PROD 2019-06-30

DROP TABLE IF EXISTS `MANDATO_CONFIGURAZIONE`;
DROP TABLE IF EXISTS `MANDATO`;
DROP TABLE IF EXISTS `SOCIETA_TUTELA`;

CREATE TABLE `SOCIETA_TUTELA` (
  `ID` INT NOT NULL AUTO_INCREMENT,
  `CODICE` CHAR(20) UNIQUE NOT NULL,
  `NOMINATIVO` CHAR(100) NOT NULL,
  `HOME_TERRITORY` CHAR(5) NOT NULL,
  `POSIZIONE_SIAE` CHAR(50) NOT NULL,
  `CODICE_SIADA` CHAR(50) NOT NULL,
  `TENANT` TINYINT NOT NULL,
  PRIMARY KEY (`ID`)
)
ENGINE = InnoDB;

CREATE TABLE `MANDATO` (
  `ID` INT NOT NULL AUTO_INCREMENT,
  `ID_MANDATARIA` INT NOT NULL,
  `ID_MANDANTE` INT NOT NULL,
  `DATA_INIZIO_MANDATO` DATETIME NOT NULL,
  `DATA_FINE_MANDATO` DATETIME DEFAULT NULL,
  PRIMARY KEY (`ID`),
  INDEX `fk_MANDATO_SOCIETA_TUTELA_idx` (`ID_MANDATARIA` ASC),
  INDEX `FK_MANDANTE_SOCIETA_TUTELA_idx` (`ID_MANDANTE` ASC),
  CONSTRAINT `FK_MANDATARIA_SOCIETA_TUTELA`
    FOREIGN KEY (`ID_MANDATARIA`)
    REFERENCES `SOCIETA_TUTELA` (`ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `FK_MANDANTE_SOCIETA_TUTELA`
    FOREIGN KEY (`ID_MANDANTE`)
    REFERENCES `SOCIETA_TUTELA` (`ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;

CREATE TABLE `MANDATO_CONFIGURAZIONE` (
  `ID` INT AUTO_INCREMENT NOT NULL,
  `ID_MANDATO` INT NOT NULL,
  `DSP` CHAR(100) NOT NULL,
  `TIPO_UTILIZZO` CHAR(50) NOT NULL,
  `OFFERTA_COMMERCIALE` CHAR(50) NOT NULL,
  `TERRITORIO` CHAR(5) NOT NULL,
  `VALIDA_DA` DATETIME NOT NULL,
  `VALIDA_A` DATETIME NULL,
  PRIMARY KEY (`ID`),
  INDEX `FK_MANDATO_idx` (`ID_MANDATO` ASC),
  CONSTRAINT `FK_MANDATO`
    FOREIGN KEY (`ID_MANDATO`)
    REFERENCES `MANDATO` (`ID`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;

DROP TABLE IF EXISTS MM_INGESTION_DOCUMENTAZIONE_MANDANTI;

CREATE TABLE MM_INGESTION_DOCUMENTAZIONE_MANDANTI
(
  ID                       BIGINT AUTO_INCREMENT NOT NULL PRIMARY KEY,
  SOCIETA                  VARCHAR(150) NOT NULL,
  DATA_INSERIMENTO         TIMESTAMP DEFAULT CURRENT_TIMESTAMP NOT NULL,
  STATO                    VARCHAR(16) NOT NULL,
  TOTALE_OPERE             BIGINT,
  TOTALE_OPERE_ACQUISITE   BIGINT,
  ESITO                    VARCHAR(16) NULL,
  MESSAGE                  VARCHAR(512),
  FILE_LOCATION            VARCHAR(512) NULL,
  FILE_NAME                VARCHAR(512) NULL
);

DROP TABLE IF EXISTS CCID_METADATA_DETAILS;

CREATE TABLE CCID_METADATA_DETAILS
(
  ID bigint AUTO_INCREMENT not null PRIMARY KEY,
  SOCIETA varchar(150) not null,
  IDENTIFICATO_VALORE decimal(40,20) not null,
  IDENTIFICATO_UTILIZZAZIONI bigint null,
  PERCENTUALE_IDENTIFICATO_UTILIZZAZIONI decimal(34,20) null,
  CLAIM_VALORE decimal(34,20) null,
  CLAIM_UTILIZZAZIONI bigint null,
  NON_IDENTIFICATO_VALORE decimal(34,20) null,
  NON_IDENTIFICATO_UTILIZZAZIONI bigint null,
  ID_DSR varchar(512) not null,
  constraint CCID_METADATA_DETAILS_CCID_METADATA_ID_DSR_fk
  foreign key (ID_DSR) references CCID_METADATA (ID_DSR)
)
;

create index CCID_METADATA_DETAILS_CCID_METADATA_ID_DSR_fk
  on CCID_METADATA_DETAILS (ID_DSR)
;

ALTER TABLE CCID_METADATA_DETAILS ADD UNIQUE  CCID_METADATA_DETAILS_UNIQUE_ID_DSR_SOCIETA_IDX (`ID_DSR`, `SOCIETA`);

ALTER TABLE DSR_METADATA ADD EXTENDED_DSR_URL VARCHAR(1024);
